/* $VER: TestArc.rexx 5.9 (12.6.93)
copyright 1990-93 Richard Lee Stockton
       FREELY DISTRIBUTABLE

     Required in C: directory:
    arc dms lha unarj unzip zoo
*/

OPTIONS FAILAT 999
CR='0D'x
PARSE ARG argname .
endtest=UPPER(RIGHT(argname,4))
arcomm=''
IF endtest='.ARC' THEN arcomm='c:arc >TestArc.txt t'
ELSE IF endtest='.ARJ' THEN arcomm='c:unarj >TestArc.txt t'
ELSE IF endtest='.DMS' THEN arcomm='c:dms >TestArc.txt VIEW'
ELSE IF endtest='.ZOO' THEN arcomm='c:zoo >TestArc.txt -t'
ELSE IF endtest='.ZIP' THEN arcomm='c:unzip >TestArc.txt -t'
ELSE IF endtest='.LHA' | endtest='.LZH' THEN
  arcomm='c:lha >TestArc.txt -N t'
IF arcomm='' THEN EXIT 0

SAY 'Testing archive integrity...'CR
ADDRESS COMMAND'CD RAM:' || '0A'x || arcomm argname
err=RC
IF err>0 THEN
  DO
    CALL DELAY(100)
    x=OPEN(f,'RAM:TestArc.txt','R')
    IF x=0 THEN
      DO i=1 WHILE ~EOF(f)
        SAY READLN(f)||CR
      END
    CALL CLOSE(f)
  END
ELSE SAY ' - Archive tested OK -'CR
EXIT err

/* TestArc.rexx */
